<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách đăng ký</h2>
        <div class="container jumbotron">
          <div class="row">
            <div class="col-2">
              <label for="">Trạng thái order</label>
            </div>
            <div class="col-3">
              <select name="" id="select-order">
                <option value="all">All</option>
                <option value="open">Open</option>
                <option value="confirmed">Confirmed</option>
                <option value="cancel">Cancel</option>
              </select>
            </div>
            <div class="col-2">
              <label for="">Last Name</label>
            </div>
            <div class="col-3">
                <select name="" id="select-pizzatype">
                    <option value="all">All</option>
                    <option value="hawaii">Hawaii</option>
                    <option value="bacon">Bacon</option>
                    <option value="seafood">Seafood</option>
                  </select>
            </div>
            <div class="col-2">
              <button class="btn btn-primary filter-user">Filter</button>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>OrderID</th>
              <th>Kích Cỡ Combo</th>
              <th>Loại Pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi Tiết</th>
            </tr>
        </table>
      </div>
</body>
</html>
<script>
    $(document).ready(function(){

    const gCOLUMN_ID = 0;
    const gCOLUMN_KICH_CO = 1;
    const gCOLUMN_LOAI_PIZZA = 2;
    const gCOLUMN_NUOC_UONG = 3;
    const gCOLUMN_THANH_TIEN = 4 ;
    const gCOLUMN_FULLNAME = 5;
    const gCOLUMN_PHONE = 6;
    const gCOLUMN_STATUS = 7;
    const gCOLUMN_ACTION = 8;
    

    const gCOL_NAME = ["orderId","kichCo" , "loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","action"]

    var gUser = {
        users:[] ,
        filterUser : function(paramFilter){
            var vResul = [] ;
            vResul = this.users.filter(function(user){
          // đây là cách lọc chỉ tương đối và là live nên chỉ cần nhập 1 vài chữ là sẽ ra tên luôn
          return ((paramFilter.trangThai == "All" || user.trangThai.toUpperCase().includes(paramFilter.trangThai.toUpperCase()))
          &&      (paramFilter.loaiPizza == "All" || user.loaiPizza.toUpperCase().includes(paramFilter.loaiPizza.toUpperCase()))) ;
        })
        return vResul
        }
        
    }
    var gUserTable = $("#user-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gCOL_NAME[gCOLUMN_ID] },
          { "data" : gCOL_NAME[gCOLUMN_KICH_CO] },
          { "data" : gCOL_NAME[gCOLUMN_LOAI_PIZZA] },
          { "data" : gCOL_NAME[gCOLUMN_NUOC_UONG] },
          { "data" : gCOL_NAME[gCOLUMN_THANH_TIEN] },
          { "data" : gCOL_NAME[gCOLUMN_FULLNAME] },
          { "data" : gCOL_NAME[gCOLUMN_PHONE] },
          { "data" : gCOL_NAME[gCOLUMN_STATUS] },
          { "data" : gCOL_NAME[gCOLUMN_ACTION] }
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs":[ 
      {
          "targets": gCOLUMN_ACTION,
          "defaultContent": "<button class = 'btn btn-primary detail-click'>Chi Tiết</button>"
      },
    ]
    });

    $(document).on("click" , ".detail-click", function(){
        onBtnDetailClick(this)
    });
    $(document).on("click" , ".filter-user" , function(){
        filterUser();
    })
    function onBtnDetailClick(paramDetail){
        var vRowSelected = $(paramDetail).parents('tr');
        //Lấy datatable row
        var vDatatableRow = gUserTable.row(vRowSelected); 
        //Lấy data của dòng 
        var vUserData = vDatatableRow.data();
        var vId = vUserData.id;

        console.log(vId)
    }

    callApiGetAllOrder();

    function filterUser(){
        var vFilter = {
            trangThai:"",
            loaiPizza:""
        }

        getSelectData(vFilter)

      var filterUser = gUser.filterUser(vFilter);

      loadDataToTable(filterUser)
    }
    function callApiGetAllOrder(){
        $.ajax({
            async:false,
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
            type: "GET",
            dataType:'json',
        success:function(res){
            console.log(JSON.stringify(res));
            gUser.users = res ;
            loadDataToTable(gUser.users)
            },
        error:function(error){
            console.assert(error)
            }
        });
    }
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gUserTable.clear();
      //Cập nhật data cho bảng 
      gUserTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gUserTable.draw();
    }

    function getSelectData(paramData){
        paramData.trangThai = $("#select-order option:selected").text()
        paramData.loaiPizza = $("#select-pizzatype option:selected").text()
    }
})

</script>